using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace NewRootProject
{
    public partial class ProjecConfigDialog : Form
    {
        public ProjecConfigDialog()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Get or set the folder that ROOT is located in.
        /// </summary>
        public string ROOTFolder
        {
            get { return tbROOTDir.Text; }
            set { tbROOTDir.Text = value; }
        }

        /// <summary>
        /// Browse for the directory that contains the ROOT directory you want
        /// to turn into a project.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bBrowseROOTDir_Click(object sender, EventArgs e)
        {
            if (fFindROOTFolder.ShowDialog() == DialogResult.OK)
            {
                ROOTFolder = fFindROOTFolder.SelectedPath;
            }
        }
    }
}
