using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Win32;
using System.IO;

namespace SAInterfaceLibrary.MSVCVersions
{
    /// <summary>
    /// Info to support MSVC.NET 2005
    /// </summary>
    class MSVC2005 : ConfigMSVCVersionInfo
    {
        public MSVC2005(string template_dir)
        {
            _name = "2005";
            _template_dir = template_dir + @"\2005";
        }

        /// <summary>
        /// Return true if we can find the 2005 unique registry entries
        /// </summary>
        override public bool IsOnMachine
        {
            get
            {
                return GetRawInstallDir() != null;
            }
        }

        protected override string IDERegKey
        {
            get
            {
                return @"SOFTWARE\Microsoft\VisualStudio\8.0";
            }
        }
    }
}
